clear all;
close all;

np = 2048;
x=0:(np-1);

fac = 3;
xe=linspace(0,fac,np);
ye=exp(xe);
figure(3)
plot(xe,ye);

ye = ye-min(ye);
ye = ye/max(ye);
ye=floor(ye*255);
yr = floor(xe/fac*255);
figure(4)
plot(xe,ye,xe,yr);

h = fopen('exp_lut.txt', 'w');
for j=1:length(x)
  fprintf(h, "%f %i \n", x(j), ye(j));
endfor
fclose(h);

xl=linspace(1, exp(3), np);
yl=log(xl);
yl=yl-min(yl);
yl = yl/max(yl);
yl2 = yl;
yl=floor(255*yl);
figure(5)
plot(xe,yl,xe,ye,xe,yr);
axis square;

h = fopen('log_lut.txt', 'w');
for j=1:length(yl)
  fprintf(h, "%f %i \n", x(j), yl(j));
endfor
fclose(h);

xs=x;
borne = 11.08252;
x=linspace(-borne/2, borne/2, np);
y=1./(1+exp(-x));
figure(6)
plot(x,y);

ys=floor(255*y);
ys(end) = 255;

xe2 = xe/max(xe);
figure(7)
plot(xe2,yl,xe2,ye,xe2,yr,xe2,ys);
axis square;
ylim([0 255]);
%print lut.fig
% need graphics_toolkit("gnuplot")

h = fopen('sig_lut.txt', 'w');
for j=1:length(yl)
  fprintf(h, "%f %i \n", xs(j), ys(j));
endfor
fclose(h);


np = 256;
x=0:(np-1);
y=x;

% 2 levels linear
N = 2;
gs = 2;
y(1:np-1) = 0;
y(end) = 255;
figure(8)
plot(x,y);
hold on;
h = fopen('lin_lut_2l.txt', 'w');
for j=1:length(x)
  fprintf(h, "%f %i \n", x(j), y(j));
endfor
fclose(h);

% 4 levels exp
N = 4;
gs = N-1;
xe=linspace(0,fac,np);
ye=exp(xe);
ye = ye-min(ye);
ye = ye/max(ye);
ye=floor(ye*gs);
ye = floor(ye/gs*255);
plot(x,ye);
hold on;
h = fopen('exp_lut_4l.txt', 'w');
for j=1:length(x)
  fprintf(h, "%f %i \n", x(j), ye(j));
endfor
fclose(h);

% 8 levels log
N=8;
gs = N-1;
xl=linspace(1, exp(3), np);
yl=log(xl);
yl=yl-min(yl);
yl = yl/max(yl);
yl2 = yl;
yl=floor(gs*yl);
yl = floor(yl/gs*255);
plot(x,yl);
hold on;
h = fopen('log_lut_8l.txt', 'w');
for j=1:length(x)
  fprintf(h, "%f %i \n", x(j), yl(j));
endfor
fclose(h);

% 16 levels sigmoid
N = 16;
gs = N-1;
borne = 11.08252;
xs=linspace(-borne/2, borne/2, np);
ys=1./(1+exp(-xs));
ys = floor(gs*ys);
ys = floor(ys/gs*255);
ys(end) = 255;
plot(x,ys);
hold on;
h = fopen('sig_lut_16l.txt', 'w');
for j=1:length(x)
  fprintf(h, "%f %i \n", x(j), ys(j));
endfor
fclose(h);

% 32 levels linear
N = 32;
gs = N-1;
y=floor(x/255*gs);
y=floor(y/gs*255);
figure(8)
plot(x,y);
hold on;
h = fopen('lin_lut_32l.txt', 'w');
for j=1:length(x)
  fprintf(h, "%f %i \n", x(j), y(j));
endfor
fclose(h);

% 64 levels exp
N = 64;
gs = N-1;
xe=linspace(0,fac,np);
ye=exp(xe);
ye = ye-min(ye);
ye = ye/max(ye);
ye=floor(ye*gs);
ye = floor(ye/gs*255);
plot(x,ye);
hold on;
h = fopen('exp_lut_64l.txt', 'w');
for j=1:length(x)
  fprintf(h, "%f %i \n", x(j), ye(j));
endfor
fclose(h);

% 128 levels log
N=128;
gs = N-1;
xl=linspace(1, exp(3), np);
yl=log(xl);
yl=yl-min(yl);
yl = yl/max(yl);
yl2 = yl;
yl=floor(gs*yl);
yl = floor(yl/gs*255);
plot(x,yl);
hold on;
h = fopen('log_lut_128l.txt', 'w');
for j=1:length(x)
  fprintf(h, "%f %i \n", x(j), yl(j));
endfor
fclose(h);

% 256 levels sigmoid
N = 256;
gs = N-1;
borne = 11.08252;
xs=linspace(-borne/2, borne/2, np);
ys=1./(1+exp(-xs));
ys = floor(gs*ys);
ys = floor(ys/gs*255);
ys(end) = 255;
plot(x,ys);
hold on;
h = fopen('sig_lut_256l.txt', 'w');
for j=1:length(x)
  fprintf(h, "%f %i \n", x(j), ys(j));
endfor
fclose(h);
